// ajouter un découpage phrase par phrase, avec le comptage de lettre et de mots dans la phrase

class texte {
  // propriétés
  int nombre_mots;
  int nombre_lettres;
  int nombre_phrases;

  String[] mots;
  String[] phrases;

  String mot;
  String phrase;
  String[] mots_phrase;

  int id_mot=0;
  int id_phrase=0;
  // inventaire
  IntDict inventaire;
  String[] tri_mot;
  int[] tri_occurence;

  // constructeur
  texte(String source) {
    String[] l=loadStrings(source);
    // Split en phrases
    phrases = join(l, " ").split("(?<=['\"\"A-Za-z0-9][\\.\\!\\?])\\s+(?=[A-Z])");
    nombre_phrases=phrases.length;
    phrase=phrases[0]; // recupere la phrase courante
    splitte_phrase(); // splitte la phrase courante
    charge_mot();

    // tri des mots dans l'inventaire
    mots=splitTokens(join(l, " "), " .\"()!?,‚;:-’'…°*«»");
    nombre_mots=mots.length;
    inventaire= new IntDict();
    cree_inventaire();
  }

  // méthodes

  void splitte_phrase() {
    phrase=phrases[id_phrase];
    mots_phrase=splitTokens(phrase, " .\"()!?,‚;:-’'…°*«»");
  }

  void phrase_suivante() {
    id_phrase++;
    if (id_phrase > nombre_phrases-1) {
      id_phrase=0;
      println("retour au début du texte");
    }
    splitte_phrase();
    id_mot=0;
    charge_mot();
  }

  void phrase_precedente() {
    id_phrase--;
    if (id_phrase < 0) {
      id_phrase=nombre_phrases-1;
      println("saut à la fin du texte");
    }
    splitte_phrase();
    id_mot=mots_phrase.length-1;
    charge_mot();
  }

  void mot_suivant() {
    id_mot++;

    if (id_mot > mots_phrase.length-1) {
      phrase_suivante();
    }
    println("je vais charger le mot "+id_mot+" sur "+mots_phrase.length);
    charge_mot();
  }

  void mot_precedent() {
    id_mot--;
    if (id_mot < 0) {
      phrase_precedente();
      id_mot=mots_phrase.length-1;
    }
    charge_mot();
  }

  void charge_mot() {
    mot=mots_phrase[id_mot];
    nombre_lettres=mot.length();
  }

  // inventaire
  void cree_inventaire() {
    for (int i=0; i<mots.length; i++) {
      // trimmer et mettre en basse casse
      String motp=trim(mots[i].toLowerCase());
      if (motp.length() > 0) {  
        if (inventaire.hasKey(motp) == false) {
          // le mot n'existe pas, l'ajouter
          inventaire.set(motp, 1);
        } else {
          // il existe : incrementer
          inventaire.increment(motp);
        }
      }
    }

    inventaire.sortValuesReverse();
    tri_mot=inventaire.keyArray();
    tri_occurence=inventaire.valueArray();
  }

  void affiche_stats() {
    textAlign(CENTER);
    text(montexte.mot, width/2, height*0.2);
    text("longueur du mot : "+montexte.nombre_lettres, width/2, height*0.45);
    text("nombre de signes de la phrase : "+montexte.phrase.length(), width/2, height*0.5);
    text("nombre de mots de la phrase : "+montexte.mots_phrase.length, width/2, height*0.55);

    text("Phrase N°"+montexte.id_phrase+", mot n°"+montexte.id_mot+" / "+montexte.mots_phrase.length, width/2, height*0.33);
    text(montexte.phrase, 20, height*0.66, width-40, height*0.3);
  }
}

// liste_fichiers(nom du dossier, extension a filtrer separés par des |);
import java.io.File; // necessaire seulement depuis la version 2b07 !

// renvoie un array de string
class liste_fichiers {
  String extension;
  String[] fichiers;
  String dossier;
  int nb_items;

  //constructeur
  liste_fichiers(String dossier, String extension) {
    this.dossier=dossier;
    this.extension=extension;
    println("je cherche dans "+sketchPath(dossier));
    fichiers = listFileNames(sketchPath(dossier), extension);
    nb_items=fichiers.length;
    println(fichiers.length + " elements dans le dossier " + sketchPath(dossier));
  }

  // listage le contenu d'un dossier en ne prenant que les extensions fournies -------------------------
  String[] listFileNames(String dir, String extension) {
    File file = new File(dir);
    if (file.isDirectory()) {
      String names[] = file.list();

      // procedure d'elimination des fichiers non concernés
      String[] names_ok= {};
      for (int i=0; i<names.length; i++) {
        String[] m1 = match(names[i], extension);
        if (m1 != null) {
          names_ok=append(names_ok, dossier+"/"+names[i]);
        }
      }
      return names_ok;
    } else {
      // If it's not a directory
      println("le nom fourni n'est pas celui d'un dossier");
      return null;
    }
  }
}